[![ubuntu 🐧](https://github.com/HorusElohim/TheBundle/actions/workflows/python-ubuntu.yml/badge.svg?branch=main)](https://github.com/HorusElohim/TheBundle/actions/workflows/python-ubuntu.yml)
[![macos 🍏](https://github.com/HorusElohim/TheBundle/actions/workflows/python-darwin.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/python-darwin.yml)
[![windows 🪟](https://github.com/HorusElohim/TheBundle/actions/workflows/python-windows.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/python-windows.yml)
[![PyPI Release 🐍](https://github.com/HorusElohim/TheBundle/actions/workflows/publish-pypi.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/publish-pypi.yml)
[![auto reference update 🔄](https://github.com/HorusElohim/TheBundle/actions/workflows/auto-reference-update.yml/badge.svg)](https://github.com/HorusElohim/TheBundle/actions/workflows/auto-reference-update.yml)

![The Bundle Dream](thebundle.gif)

# TheBundle

**TheBundle** is a modern, extensible Python framework for robust, maintainable, and high-performance software projects. It provides a suite of core modules for logging, tracing, data modeling, process management, ZeroMQ sockets, browser automation, and more—plus advanced testing and pybind11/C++ extension tooling.

**Install**:  
```sh
pip install thebundle
```

### Continuous Integration: Platforms & Python Versions

| Platform  | Python Versions  |
| --------- | ---------------- |
| 🐧 Ubuntu  | 3.10 3.11, 3.12 |
| 🍏 macOS   | 3.10, 3.11, 3.12 |
| 🪟 Windows | 3.10, 3.11, 3.12 |

## Documentation
For more information, see the inline documentation in each module and the example projects in `tests/`.
- [Core Modules Guide](src/bundle/core/README.md)
- [Testing Module Guide](src/bundle/testing/README.md)
- [Pybind Subpackage Guide](src/bundle/pybind/README.md)


## License

Licensed under the Apache License, Version 2.0. See [LICENSE](LICENSE) for details.



